> ## Documentation Index
> Fetch the complete documentation index at: https://private-7c7dfe99-mintlify-8a08bda2.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create reverse private endpoint

> **This endpoint is in beta.** API contract is stable, and no breaking changes are expected in the future. <br /><br /> Create a new reverse private endpoint.



## OpenAPI

````yaml /_specs/cloud-openapi.json post /v1/organizations/{organizationId}/services/{serviceId}/clickpipesReversePrivateEndpoints
openapi: 3.0.1
info:
  title: OpenAPI spec for ClickHouse Cloud
  version: '1.0'
  contact:
    name: ClickHouse Support
    url: >-
      https://clickhouse.com/docs/en/cloud/manage/openapi?referrer=openapi-299828
    email: support@clickhouse.com
servers:
  - url: https://api.clickhouse.cloud
security:
  - basicAuth: []
tags:
  - name: Organization
  - name: User management
  - name: Billing
  - name: Service
  - name: Backup
  - name: OpenAPI
  - name: Prometheus
  - name: ClickPipes
paths:
  /v1/organizations/{organizationId}/services/{serviceId}/clickpipesReversePrivateEndpoints:
    post:
      tags:
        - ClickPipes
      summary: Create reverse private endpoint
      description: >-
        **This endpoint is in beta.** API contract is stable, and no breaking
        changes are expected in the future. <br /><br /> Create a new reverse
        private endpoint.
      parameters:
        - in: path
          name: organizationId
          description: ID of the organization that owns the service.
          required: true
          schema:
            type: string
            format: uuid
        - in: path
          name: serviceId
          description: ID of the service that owns the Reverse Private Endpoint.
          required: true
          schema:
            type: string
            format: uuid
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateReversePrivateEndpoint'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: number
                    description: HTTP status code.
                    example: 200
                  requestId:
                    type: string
                    description: Unique id assigned to every request. UUIDv4
                    format: uuid
                  result:
                    $ref: '#/components/schemas/ReversePrivateEndpoint'
        '400':
          description: >-
            The server cannot or will not process the request due to something
            that is perceived to be a client error.
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: number
                    description: HTTP status code.
                    example: 400
                  error:
                    type: string
                    description: Detailed error description.
components:
  schemas:
    CreateReversePrivateEndpoint:
      properties:
        description:
          description: >-
            Reverse private endpoint description. Maximum length is 255
            characters.
          type: string
          example: My reverse private endpoint
        type:
          description: Reverse private endpoint type.
          type: string
          enum:
            - VPC_ENDPOINT_SERVICE
            - VPC_RESOURCE
            - MSK_MULTI_VPC
          example: VPC_ENDPOINT_SERVICE
        vpcEndpointServiceName:
          description: VPC endpoint service name.
          nullable: true
          type: string
          example: com.amazonaws.vpce.us-east-1.vpce-svc-12345678901234567
        vpcResourceConfigurationId:
          description: VPC resource configuration ID. Required for VPC_RESOURCE type.
          nullable: true
          type: string
          example: rcfg-12345678901234567
        vpcResourceShareArn:
          description: VPC resource share ARN. Required for VPC_RESOURCE type.
          nullable: true
          type: string
          example: >-
            arn:aws:ram:us-east-1:123456789012:resource-share/share-12345678901234567
        mskClusterArn:
          description: MSK cluster ARN. Required for MSK_MULTI_VPC type.
          nullable: true
          type: string
          example: arn:aws:kafka:us-east-1:123456789012:cluster/my-cluster
        mskAuthentication:
          description: MSK cluster authentication type. Required for MSK_MULTI_VPC type.
          nullable: true
          type: string
          enum:
            - SASL_IAM
            - SASL_SCRAM
          example: SASL_IAM
    ReversePrivateEndpoint:
      properties:
        description:
          description: >-
            Reverse private endpoint description. Maximum length is 255
            characters.
          type: string
          example: My reverse private endpoint
        type:
          description: Reverse private endpoint type.
          type: string
          enum:
            - VPC_ENDPOINT_SERVICE
            - VPC_RESOURCE
            - MSK_MULTI_VPC
          example: VPC_ENDPOINT_SERVICE
        vpcEndpointServiceName:
          description: VPC endpoint service name.
          nullable: true
          type: string
          example: com.amazonaws.vpce.us-east-1.vpce-svc-12345678901234567
        vpcResourceConfigurationId:
          description: VPC resource configuration ID. Required for VPC_RESOURCE type.
          nullable: true
          type: string
          example: rcfg-12345678901234567
        vpcResourceShareArn:
          description: VPC resource share ARN. Required for VPC_RESOURCE type.
          nullable: true
          type: string
          example: >-
            arn:aws:ram:us-east-1:123456789012:resource-share/share-12345678901234567
        mskClusterArn:
          description: MSK cluster ARN. Required for MSK_MULTI_VPC type.
          nullable: true
          type: string
          example: arn:aws:kafka:us-east-1:123456789012:cluster/my-cluster
        mskAuthentication:
          description: MSK cluster authentication type. Required for MSK_MULTI_VPC type.
          nullable: true
          type: string
          enum:
            - SASL_IAM
            - SASL_SCRAM
          example: SASL_IAM
        id:
          description: Reverse private endpoint ID.
          type: string
          format: uuid
          example: 12345678-1234-1234-1234-123456789012
        serviceId:
          description: ClickHouse service ID reverse private endpoint is associated with.
          type: string
          format: uuid
          example: 12345678-1234-1234-1234-123456789012
        endpointId:
          description: Reverse private endpoint endpoint ID.
          type: string
          example: vpce-12345678901234567
        dnsNames:
          type: array
          description: Reverse private endpoint internal DNS names.
          items:
            type: string
        privateDnsNames:
          type: array
          description: Reverse private endpoint private DNS names.
          items:
            type: string
        status:
          description: Reverse private endpoint status.
          type: string
          enum:
            - Unknown
            - Provisioning
            - Deleting
            - Ready
            - Failed
            - PendingAcceptance
            - Rejected
            - Expired
          example: Ready
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic
      description: >-
        Use key ID and key secret obtained in ClickHouse Cloud console:
        https://clickhouse.com/docs/cloud/manage/openapi

````